<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_17</title>
</head>
<body>
    <h1>Capitulo 17</h1>
    <a>Ejercicio 20</a>

    <script>

        const medianaConti = (a) => {

            let med = a[0];
            let smaller = [];
            let greater = [];
           
            smaller.push(a[0]);
            console.log(`Primera Media del arreglo: ${med}`);

            for(let i = 1; i < a.length; i++) {
               
                let x = a[i];

                if(smaller.length > greater.length) {
                    if(x < med) {

                        smaller.sort(function(a,b){return b-a;});                     
                        greater.push(smaller.shift());
                        smaller.push(x);
                    } else {    
                        greater.push(x);
                    }

                    smaller.sort(function(a,b){return b-a;});
                    greater.sort(function(a,b){return a-b;});
                    med = (smaller[0] + greater[0])/2;
                 
                } else if(smaller.length == greater.length) {

                    if(x < med) {
                        smaller.push(x);
                        smaller.sort(function(a,b){return b-a;});         
                        med = smaller[0];
                    } else {
                        greater.push(x);                     
                        greater.sort(function(a,b){return a-b;});
                        med = greater[0];
                    }
                } else {

                    if(x > med) {
                        greater.sort(function(a,b){return a-b;});
                        smaller.push(greater.shift());
                        greater.push(x);
                    } else {
                        smaller.push(x);
                    }
                    smaller.sort(function(a,b){return b-a;});
                    med = (smaller[0] + greater[0])/2;
                   
                }
                
                console.log(`Media Continua siguiente: ${med}`);
             
            }
        }
 
        let arr=[5, 15, 10, 20, 3];
        medianaConti(arr);

    </script>
    
</body>
</html>